"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeReviewSummary = exports.MetricsSummary = exports.ListCodeReviewsRequest = exports.DisassociateRepositoryResponse = exports.DisassociateRepositoryRequest = exports.NotFoundException = exports.DescribeRepositoryAssociationResponse = exports.DescribeRepositoryAssociationRequest = exports.DescribeRecommendationFeedbackResponse = exports.RecommendationFeedback = exports.Reaction = exports.DescribeRecommendationFeedbackRequest = exports.DescribeCodeReviewResponse = exports.DescribeCodeReviewRequest = exports.ResourceNotFoundException = exports.CreateCodeReviewResponse = exports.CodeReview = exports.Type = exports.JobState = exports.Metrics = exports.CreateCodeReviewRequest = exports.CodeReviewType = exports.RepositoryAnalysis = exports.SourceCodeType = exports.S3BucketRepository = exports.RequestMetadata = exports.VendorName = exports.EventInfo = exports.CommitDiffSourceCodeType = exports.BranchDiffSourceCodeType = exports.RepositoryHeadSourceCodeType = exports.ValidationException = exports.ThrottlingException = exports.InternalServerException = exports.ConflictException = exports.AssociateRepositoryResponse = exports.RepositoryAssociation = exports.RepositoryAssociationState = exports.S3RepositoryDetails = exports.CodeArtifacts = exports.ProviderType = exports.AssociateRepositoryRequest = exports.Repository = exports.S3Repository = exports.CodeCommitRepository = exports.ThirdPartySourceRepository = exports.KMSKeyDetails = exports.EncryptionOption = exports.AnalysisType = exports.AccessDeniedException = void 0;
exports.UntagResourceResponse = exports.UntagResourceRequest = exports.TagResourceResponse = exports.TagResourceRequest = exports.PutRecommendationFeedbackResponse = exports.PutRecommendationFeedbackRequest = exports.ListTagsForResourceResponse = exports.ListTagsForResourceRequest = exports.ListRepositoryAssociationsResponse = exports.RepositoryAssociationSummary = exports.ListRepositoryAssociationsRequest = exports.ListRecommendationsResponse = exports.RecommendationSummary = exports.Severity = exports.RuleMetadata = exports.RecommendationCategory = exports.ListRecommendationsRequest = exports.ListRecommendationFeedbackResponse = exports.RecommendationFeedbackSummary = exports.ListRecommendationFeedbackRequest = exports.ListCodeReviewsResponse = void 0;
const CodeGuruReviewerServiceException_1 = require("./CodeGuruReviewerServiceException");
class AccessDeniedException extends CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException {
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        this.name = "AccessDeniedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
        this.Message = opts.Message;
    }
}
exports.AccessDeniedException = AccessDeniedException;
var AnalysisType;
(function (AnalysisType) {
    AnalysisType["CODE_QUALITY"] = "CodeQuality";
    AnalysisType["SECURITY"] = "Security";
})(AnalysisType = exports.AnalysisType || (exports.AnalysisType = {}));
var EncryptionOption;
(function (EncryptionOption) {
    EncryptionOption["AoCmk"] = "AWS_OWNED_CMK";
    EncryptionOption["CmCmk"] = "CUSTOMER_MANAGED_CMK";
})(EncryptionOption = exports.EncryptionOption || (exports.EncryptionOption = {}));
var KMSKeyDetails;
(function (KMSKeyDetails) {
    KMSKeyDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(KMSKeyDetails = exports.KMSKeyDetails || (exports.KMSKeyDetails = {}));
var ThirdPartySourceRepository;
(function (ThirdPartySourceRepository) {
    ThirdPartySourceRepository.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ThirdPartySourceRepository = exports.ThirdPartySourceRepository || (exports.ThirdPartySourceRepository = {}));
var CodeCommitRepository;
(function (CodeCommitRepository) {
    CodeCommitRepository.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CodeCommitRepository = exports.CodeCommitRepository || (exports.CodeCommitRepository = {}));
var S3Repository;
(function (S3Repository) {
    S3Repository.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(S3Repository = exports.S3Repository || (exports.S3Repository = {}));
var Repository;
(function (Repository) {
    Repository.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Repository = exports.Repository || (exports.Repository = {}));
var AssociateRepositoryRequest;
(function (AssociateRepositoryRequest) {
    AssociateRepositoryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(AssociateRepositoryRequest = exports.AssociateRepositoryRequest || (exports.AssociateRepositoryRequest = {}));
var ProviderType;
(function (ProviderType) {
    ProviderType["BITBUCKET"] = "Bitbucket";
    ProviderType["CODE_COMMIT"] = "CodeCommit";
    ProviderType["GIT_HUB"] = "GitHub";
    ProviderType["GIT_HUB_ENTERPRISE_SERVER"] = "GitHubEnterpriseServer";
    ProviderType["S3_BUCKET"] = "S3Bucket";
})(ProviderType = exports.ProviderType || (exports.ProviderType = {}));
var CodeArtifacts;
(function (CodeArtifacts) {
    CodeArtifacts.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CodeArtifacts = exports.CodeArtifacts || (exports.CodeArtifacts = {}));
var S3RepositoryDetails;
(function (S3RepositoryDetails) {
    S3RepositoryDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(S3RepositoryDetails = exports.S3RepositoryDetails || (exports.S3RepositoryDetails = {}));
var RepositoryAssociationState;
(function (RepositoryAssociationState) {
    RepositoryAssociationState["ASSOCIATED"] = "Associated";
    RepositoryAssociationState["ASSOCIATING"] = "Associating";
    RepositoryAssociationState["DISASSOCIATED"] = "Disassociated";
    RepositoryAssociationState["DISASSOCIATING"] = "Disassociating";
    RepositoryAssociationState["FAILED"] = "Failed";
})(RepositoryAssociationState = exports.RepositoryAssociationState || (exports.RepositoryAssociationState = {}));
var RepositoryAssociation;
(function (RepositoryAssociation) {
    RepositoryAssociation.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RepositoryAssociation = exports.RepositoryAssociation || (exports.RepositoryAssociation = {}));
var AssociateRepositoryResponse;
(function (AssociateRepositoryResponse) {
    AssociateRepositoryResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(AssociateRepositoryResponse = exports.AssociateRepositoryResponse || (exports.AssociateRepositoryResponse = {}));
class ConflictException extends CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException {
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConflictException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConflictException.prototype);
        this.Message = opts.Message;
    }
}
exports.ConflictException = ConflictException;
class InternalServerException extends CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException {
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServerException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServerException.prototype);
        this.Message = opts.Message;
    }
}
exports.InternalServerException = InternalServerException;
class ThrottlingException extends CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottlingException.prototype);
        this.Message = opts.Message;
    }
}
exports.ThrottlingException = ThrottlingException;
class ValidationException extends CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
        this.Message = opts.Message;
    }
}
exports.ValidationException = ValidationException;
var RepositoryHeadSourceCodeType;
(function (RepositoryHeadSourceCodeType) {
    RepositoryHeadSourceCodeType.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RepositoryHeadSourceCodeType = exports.RepositoryHeadSourceCodeType || (exports.RepositoryHeadSourceCodeType = {}));
var BranchDiffSourceCodeType;
(function (BranchDiffSourceCodeType) {
    BranchDiffSourceCodeType.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(BranchDiffSourceCodeType = exports.BranchDiffSourceCodeType || (exports.BranchDiffSourceCodeType = {}));
var CommitDiffSourceCodeType;
(function (CommitDiffSourceCodeType) {
    CommitDiffSourceCodeType.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CommitDiffSourceCodeType = exports.CommitDiffSourceCodeType || (exports.CommitDiffSourceCodeType = {}));
var EventInfo;
(function (EventInfo) {
    EventInfo.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(EventInfo = exports.EventInfo || (exports.EventInfo = {}));
var VendorName;
(function (VendorName) {
    VendorName["GITHUB"] = "GitHub";
    VendorName["GITLAB"] = "GitLab";
    VendorName["NATIVE_S3"] = "NativeS3";
})(VendorName = exports.VendorName || (exports.VendorName = {}));
var RequestMetadata;
(function (RequestMetadata) {
    RequestMetadata.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RequestMetadata = exports.RequestMetadata || (exports.RequestMetadata = {}));
var S3BucketRepository;
(function (S3BucketRepository) {
    S3BucketRepository.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(S3BucketRepository = exports.S3BucketRepository || (exports.S3BucketRepository = {}));
var SourceCodeType;
(function (SourceCodeType) {
    SourceCodeType.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SourceCodeType = exports.SourceCodeType || (exports.SourceCodeType = {}));
var RepositoryAnalysis;
(function (RepositoryAnalysis) {
    RepositoryAnalysis.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RepositoryAnalysis = exports.RepositoryAnalysis || (exports.RepositoryAnalysis = {}));
var CodeReviewType;
(function (CodeReviewType) {
    CodeReviewType.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CodeReviewType = exports.CodeReviewType || (exports.CodeReviewType = {}));
var CreateCodeReviewRequest;
(function (CreateCodeReviewRequest) {
    CreateCodeReviewRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateCodeReviewRequest = exports.CreateCodeReviewRequest || (exports.CreateCodeReviewRequest = {}));
var Metrics;
(function (Metrics) {
    Metrics.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Metrics = exports.Metrics || (exports.Metrics = {}));
var JobState;
(function (JobState) {
    JobState["COMPLETED"] = "Completed";
    JobState["DELETING"] = "Deleting";
    JobState["FAILED"] = "Failed";
    JobState["PENDING"] = "Pending";
})(JobState = exports.JobState || (exports.JobState = {}));
var Type;
(function (Type) {
    Type["PULL_REQUEST"] = "PullRequest";
    Type["REPOSITORY_ANALYSIS"] = "RepositoryAnalysis";
})(Type = exports.Type || (exports.Type = {}));
var CodeReview;
(function (CodeReview) {
    CodeReview.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CodeReview = exports.CodeReview || (exports.CodeReview = {}));
var CreateCodeReviewResponse;
(function (CreateCodeReviewResponse) {
    CreateCodeReviewResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateCodeReviewResponse = exports.CreateCodeReviewResponse || (exports.CreateCodeReviewResponse = {}));
class ResourceNotFoundException extends CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.Message = opts.Message;
    }
}
exports.ResourceNotFoundException = ResourceNotFoundException;
var DescribeCodeReviewRequest;
(function (DescribeCodeReviewRequest) {
    DescribeCodeReviewRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeCodeReviewRequest = exports.DescribeCodeReviewRequest || (exports.DescribeCodeReviewRequest = {}));
var DescribeCodeReviewResponse;
(function (DescribeCodeReviewResponse) {
    DescribeCodeReviewResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeCodeReviewResponse = exports.DescribeCodeReviewResponse || (exports.DescribeCodeReviewResponse = {}));
var DescribeRecommendationFeedbackRequest;
(function (DescribeRecommendationFeedbackRequest) {
    DescribeRecommendationFeedbackRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeRecommendationFeedbackRequest = exports.DescribeRecommendationFeedbackRequest || (exports.DescribeRecommendationFeedbackRequest = {}));
var Reaction;
(function (Reaction) {
    Reaction["THUMBS_DOWN"] = "ThumbsDown";
    Reaction["THUMBS_UP"] = "ThumbsUp";
})(Reaction = exports.Reaction || (exports.Reaction = {}));
var RecommendationFeedback;
(function (RecommendationFeedback) {
    RecommendationFeedback.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RecommendationFeedback = exports.RecommendationFeedback || (exports.RecommendationFeedback = {}));
var DescribeRecommendationFeedbackResponse;
(function (DescribeRecommendationFeedbackResponse) {
    DescribeRecommendationFeedbackResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeRecommendationFeedbackResponse = exports.DescribeRecommendationFeedbackResponse || (exports.DescribeRecommendationFeedbackResponse = {}));
var DescribeRepositoryAssociationRequest;
(function (DescribeRepositoryAssociationRequest) {
    DescribeRepositoryAssociationRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeRepositoryAssociationRequest = exports.DescribeRepositoryAssociationRequest || (exports.DescribeRepositoryAssociationRequest = {}));
var DescribeRepositoryAssociationResponse;
(function (DescribeRepositoryAssociationResponse) {
    DescribeRepositoryAssociationResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeRepositoryAssociationResponse = exports.DescribeRepositoryAssociationResponse || (exports.DescribeRepositoryAssociationResponse = {}));
class NotFoundException extends CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException {
    constructor(opts) {
        super({
            name: "NotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "NotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, NotFoundException.prototype);
        this.Message = opts.Message;
    }
}
exports.NotFoundException = NotFoundException;
var DisassociateRepositoryRequest;
(function (DisassociateRepositoryRequest) {
    DisassociateRepositoryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DisassociateRepositoryRequest = exports.DisassociateRepositoryRequest || (exports.DisassociateRepositoryRequest = {}));
var DisassociateRepositoryResponse;
(function (DisassociateRepositoryResponse) {
    DisassociateRepositoryResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DisassociateRepositoryResponse = exports.DisassociateRepositoryResponse || (exports.DisassociateRepositoryResponse = {}));
var ListCodeReviewsRequest;
(function (ListCodeReviewsRequest) {
    ListCodeReviewsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListCodeReviewsRequest = exports.ListCodeReviewsRequest || (exports.ListCodeReviewsRequest = {}));
var MetricsSummary;
(function (MetricsSummary) {
    MetricsSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(MetricsSummary = exports.MetricsSummary || (exports.MetricsSummary = {}));
var CodeReviewSummary;
(function (CodeReviewSummary) {
    CodeReviewSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CodeReviewSummary = exports.CodeReviewSummary || (exports.CodeReviewSummary = {}));
var ListCodeReviewsResponse;
(function (ListCodeReviewsResponse) {
    ListCodeReviewsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListCodeReviewsResponse = exports.ListCodeReviewsResponse || (exports.ListCodeReviewsResponse = {}));
var ListRecommendationFeedbackRequest;
(function (ListRecommendationFeedbackRequest) {
    ListRecommendationFeedbackRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListRecommendationFeedbackRequest = exports.ListRecommendationFeedbackRequest || (exports.ListRecommendationFeedbackRequest = {}));
var RecommendationFeedbackSummary;
(function (RecommendationFeedbackSummary) {
    RecommendationFeedbackSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RecommendationFeedbackSummary = exports.RecommendationFeedbackSummary || (exports.RecommendationFeedbackSummary = {}));
var ListRecommendationFeedbackResponse;
(function (ListRecommendationFeedbackResponse) {
    ListRecommendationFeedbackResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListRecommendationFeedbackResponse = exports.ListRecommendationFeedbackResponse || (exports.ListRecommendationFeedbackResponse = {}));
var ListRecommendationsRequest;
(function (ListRecommendationsRequest) {
    ListRecommendationsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListRecommendationsRequest = exports.ListRecommendationsRequest || (exports.ListRecommendationsRequest = {}));
var RecommendationCategory;
(function (RecommendationCategory) {
    RecommendationCategory["AWS_BEST_PRACTICES"] = "AWSBestPractices";
    RecommendationCategory["AWS_CLOUDFORMATION_ISSUES"] = "AWSCloudFormationIssues";
    RecommendationCategory["CODE_INCONSISTENCIES"] = "CodeInconsistencies";
    RecommendationCategory["CODE_MAINTENANCE_ISSUES"] = "CodeMaintenanceIssues";
    RecommendationCategory["CONCURRENCY_ISSUES"] = "ConcurrencyIssues";
    RecommendationCategory["DUPLICATE_CODE"] = "DuplicateCode";
    RecommendationCategory["INPUT_VALIDATIONS"] = "InputValidations";
    RecommendationCategory["JAVA_BEST_PRACTICES"] = "JavaBestPractices";
    RecommendationCategory["PYTHON_BEST_PRACTICES"] = "PythonBestPractices";
    RecommendationCategory["RESOURCE_LEAKS"] = "ResourceLeaks";
    RecommendationCategory["SECURITY_ISSUES"] = "SecurityIssues";
})(RecommendationCategory = exports.RecommendationCategory || (exports.RecommendationCategory = {}));
var RuleMetadata;
(function (RuleMetadata) {
    RuleMetadata.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RuleMetadata = exports.RuleMetadata || (exports.RuleMetadata = {}));
var Severity;
(function (Severity) {
    Severity["CRITICAL"] = "Critical";
    Severity["HIGH"] = "High";
    Severity["INFO"] = "Info";
    Severity["LOW"] = "Low";
    Severity["MEDIUM"] = "Medium";
})(Severity = exports.Severity || (exports.Severity = {}));
var RecommendationSummary;
(function (RecommendationSummary) {
    RecommendationSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RecommendationSummary = exports.RecommendationSummary || (exports.RecommendationSummary = {}));
var ListRecommendationsResponse;
(function (ListRecommendationsResponse) {
    ListRecommendationsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListRecommendationsResponse = exports.ListRecommendationsResponse || (exports.ListRecommendationsResponse = {}));
var ListRepositoryAssociationsRequest;
(function (ListRepositoryAssociationsRequest) {
    ListRepositoryAssociationsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListRepositoryAssociationsRequest = exports.ListRepositoryAssociationsRequest || (exports.ListRepositoryAssociationsRequest = {}));
var RepositoryAssociationSummary;
(function (RepositoryAssociationSummary) {
    RepositoryAssociationSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RepositoryAssociationSummary = exports.RepositoryAssociationSummary || (exports.RepositoryAssociationSummary = {}));
var ListRepositoryAssociationsResponse;
(function (ListRepositoryAssociationsResponse) {
    ListRepositoryAssociationsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListRepositoryAssociationsResponse = exports.ListRepositoryAssociationsResponse || (exports.ListRepositoryAssociationsResponse = {}));
var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceRequest = exports.ListTagsForResourceRequest || (exports.ListTagsForResourceRequest = {}));
var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceResponse = exports.ListTagsForResourceResponse || (exports.ListTagsForResourceResponse = {}));
var PutRecommendationFeedbackRequest;
(function (PutRecommendationFeedbackRequest) {
    PutRecommendationFeedbackRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutRecommendationFeedbackRequest = exports.PutRecommendationFeedbackRequest || (exports.PutRecommendationFeedbackRequest = {}));
var PutRecommendationFeedbackResponse;
(function (PutRecommendationFeedbackResponse) {
    PutRecommendationFeedbackResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutRecommendationFeedbackResponse = exports.PutRecommendationFeedbackResponse || (exports.PutRecommendationFeedbackResponse = {}));
var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceRequest = exports.TagResourceRequest || (exports.TagResourceRequest = {}));
var TagResourceResponse;
(function (TagResourceResponse) {
    TagResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceResponse = exports.TagResourceResponse || (exports.TagResourceResponse = {}));
var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceRequest = exports.UntagResourceRequest || (exports.UntagResourceRequest = {}));
var UntagResourceResponse;
(function (UntagResourceResponse) {
    UntagResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceResponse = exports.UntagResourceResponse || (exports.UntagResourceResponse = {}));
