"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAws_restJson1UntagResourceCommand = exports.deserializeAws_restJson1TagResourceCommand = exports.deserializeAws_restJson1PutRecommendationFeedbackCommand = exports.deserializeAws_restJson1ListTagsForResourceCommand = exports.deserializeAws_restJson1ListRepositoryAssociationsCommand = exports.deserializeAws_restJson1ListRecommendationsCommand = exports.deserializeAws_restJson1ListRecommendationFeedbackCommand = exports.deserializeAws_restJson1ListCodeReviewsCommand = exports.deserializeAws_restJson1DisassociateRepositoryCommand = exports.deserializeAws_restJson1DescribeRepositoryAssociationCommand = exports.deserializeAws_restJson1DescribeRecommendationFeedbackCommand = exports.deserializeAws_restJson1DescribeCodeReviewCommand = exports.deserializeAws_restJson1CreateCodeReviewCommand = exports.deserializeAws_restJson1AssociateRepositoryCommand = exports.serializeAws_restJson1UntagResourceCommand = exports.serializeAws_restJson1TagResourceCommand = exports.serializeAws_restJson1PutRecommendationFeedbackCommand = exports.serializeAws_restJson1ListTagsForResourceCommand = exports.serializeAws_restJson1ListRepositoryAssociationsCommand = exports.serializeAws_restJson1ListRecommendationsCommand = exports.serializeAws_restJson1ListRecommendationFeedbackCommand = exports.serializeAws_restJson1ListCodeReviewsCommand = exports.serializeAws_restJson1DisassociateRepositoryCommand = exports.serializeAws_restJson1DescribeRepositoryAssociationCommand = exports.serializeAws_restJson1DescribeRecommendationFeedbackCommand = exports.serializeAws_restJson1DescribeCodeReviewCommand = exports.serializeAws_restJson1CreateCodeReviewCommand = exports.serializeAws_restJson1AssociateRepositoryCommand = void 0;
const protocol_http_1 = require("@aws-sdk/protocol-http");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const uuid_1 = require("uuid");
const CodeGuruReviewerServiceException_1 = require("../models/CodeGuruReviewerServiceException");
const models_0_1 = require("../models/models_0");
const serializeAws_restJson1AssociateRepositoryCommand = async (input, context) => {
    var _a;
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/associations";
    let body;
    body = JSON.stringify({
        ClientRequestToken: (_a = input.ClientRequestToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.KMSKeyDetails !== undefined &&
            input.KMSKeyDetails !== null && {
            KMSKeyDetails: serializeAws_restJson1KMSKeyDetails(input.KMSKeyDetails, context),
        }),
        ...(input.Repository !== undefined &&
            input.Repository !== null && { Repository: serializeAws_restJson1Repository(input.Repository, context) }),
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_restJson1TagMap(input.Tags, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1AssociateRepositoryCommand = serializeAws_restJson1AssociateRepositoryCommand;
const serializeAws_restJson1CreateCodeReviewCommand = async (input, context) => {
    var _a;
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/codereviews";
    let body;
    body = JSON.stringify({
        ClientRequestToken: (_a = input.ClientRequestToken) !== null && _a !== void 0 ? _a : (0, uuid_1.v4)(),
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
        ...(input.RepositoryAssociationArn !== undefined &&
            input.RepositoryAssociationArn !== null && { RepositoryAssociationArn: input.RepositoryAssociationArn }),
        ...(input.Type !== undefined &&
            input.Type !== null && { Type: serializeAws_restJson1CodeReviewType(input.Type, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1CreateCodeReviewCommand = serializeAws_restJson1CreateCodeReviewCommand;
const serializeAws_restJson1DescribeCodeReviewCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/codereviews/{CodeReviewArn}";
    if (input.CodeReviewArn !== undefined) {
        const labelValue = input.CodeReviewArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: CodeReviewArn.");
        }
        resolvedPath = resolvedPath.replace("{CodeReviewArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: CodeReviewArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeCodeReviewCommand = serializeAws_restJson1DescribeCodeReviewCommand;
const serializeAws_restJson1DescribeRecommendationFeedbackCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/feedback/{CodeReviewArn}";
    if (input.CodeReviewArn !== undefined) {
        const labelValue = input.CodeReviewArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: CodeReviewArn.");
        }
        resolvedPath = resolvedPath.replace("{CodeReviewArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: CodeReviewArn.");
    }
    const query = {
        ...(input.RecommendationId !== undefined && { RecommendationId: input.RecommendationId }),
        ...(input.UserId !== undefined && { UserId: input.UserId }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1DescribeRecommendationFeedbackCommand = serializeAws_restJson1DescribeRecommendationFeedbackCommand;
const serializeAws_restJson1DescribeRepositoryAssociationCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/associations/{AssociationArn}";
    if (input.AssociationArn !== undefined) {
        const labelValue = input.AssociationArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: AssociationArn.");
        }
        resolvedPath = resolvedPath.replace("{AssociationArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: AssociationArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DescribeRepositoryAssociationCommand = serializeAws_restJson1DescribeRepositoryAssociationCommand;
const serializeAws_restJson1DisassociateRepositoryCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/associations/{AssociationArn}";
    if (input.AssociationArn !== undefined) {
        const labelValue = input.AssociationArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: AssociationArn.");
        }
        resolvedPath = resolvedPath.replace("{AssociationArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: AssociationArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1DisassociateRepositoryCommand = serializeAws_restJson1DisassociateRepositoryCommand;
const serializeAws_restJson1ListCodeReviewsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/codereviews";
    const query = {
        ...(input.ProviderTypes !== undefined && {
            ProviderTypes: (input.ProviderTypes || []).map((_entry) => _entry),
        }),
        ...(input.States !== undefined && { States: (input.States || []).map((_entry) => _entry) }),
        ...(input.RepositoryNames !== undefined && {
            RepositoryNames: (input.RepositoryNames || []).map((_entry) => _entry),
        }),
        ...(input.Type !== undefined && { Type: input.Type }),
        ...(input.MaxResults !== undefined && { MaxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { NextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListCodeReviewsCommand = serializeAws_restJson1ListCodeReviewsCommand;
const serializeAws_restJson1ListRecommendationFeedbackCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/feedback/{CodeReviewArn}/RecommendationFeedback";
    if (input.CodeReviewArn !== undefined) {
        const labelValue = input.CodeReviewArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: CodeReviewArn.");
        }
        resolvedPath = resolvedPath.replace("{CodeReviewArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: CodeReviewArn.");
    }
    const query = {
        ...(input.NextToken !== undefined && { NextToken: input.NextToken }),
        ...(input.MaxResults !== undefined && { MaxResults: input.MaxResults.toString() }),
        ...(input.UserIds !== undefined && { UserIds: (input.UserIds || []).map((_entry) => _entry) }),
        ...(input.RecommendationIds !== undefined && {
            RecommendationIds: (input.RecommendationIds || []).map((_entry) => _entry),
        }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListRecommendationFeedbackCommand = serializeAws_restJson1ListRecommendationFeedbackCommand;
const serializeAws_restJson1ListRecommendationsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` +
        "/codereviews/{CodeReviewArn}/Recommendations";
    if (input.CodeReviewArn !== undefined) {
        const labelValue = input.CodeReviewArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: CodeReviewArn.");
        }
        resolvedPath = resolvedPath.replace("{CodeReviewArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: CodeReviewArn.");
    }
    const query = {
        ...(input.NextToken !== undefined && { NextToken: input.NextToken }),
        ...(input.MaxResults !== undefined && { MaxResults: input.MaxResults.toString() }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListRecommendationsCommand = serializeAws_restJson1ListRecommendationsCommand;
const serializeAws_restJson1ListRepositoryAssociationsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/associations";
    const query = {
        ...(input.ProviderTypes !== undefined && {
            ProviderType: (input.ProviderTypes || []).map((_entry) => _entry),
        }),
        ...(input.States !== undefined && { State: (input.States || []).map((_entry) => _entry) }),
        ...(input.Names !== undefined && { Name: (input.Names || []).map((_entry) => _entry) }),
        ...(input.Owners !== undefined && { Owner: (input.Owners || []).map((_entry) => _entry) }),
        ...(input.MaxResults !== undefined && { MaxResults: input.MaxResults.toString() }),
        ...(input.NextToken !== undefined && { NextToken: input.NextToken }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListRepositoryAssociationsCommand = serializeAws_restJson1ListRepositoryAssociationsCommand;
const serializeAws_restJson1ListTagsForResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{resourceArn}";
    if (input.resourceArn !== undefined) {
        const labelValue = input.resourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: resourceArn.");
        }
        resolvedPath = resolvedPath.replace("{resourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: resourceArn.");
    }
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1ListTagsForResourceCommand = serializeAws_restJson1ListTagsForResourceCommand;
const serializeAws_restJson1PutRecommendationFeedbackCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/feedback";
    let body;
    body = JSON.stringify({
        ...(input.CodeReviewArn !== undefined && input.CodeReviewArn !== null && { CodeReviewArn: input.CodeReviewArn }),
        ...(input.Reactions !== undefined &&
            input.Reactions !== null && { Reactions: serializeAws_restJson1Reactions(input.Reactions, context) }),
        ...(input.RecommendationId !== undefined &&
            input.RecommendationId !== null && { RecommendationId: input.RecommendationId }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1PutRecommendationFeedbackCommand = serializeAws_restJson1PutRecommendationFeedbackCommand;
const serializeAws_restJson1TagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{resourceArn}";
    if (input.resourceArn !== undefined) {
        const labelValue = input.resourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: resourceArn.");
        }
        resolvedPath = resolvedPath.replace("{resourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: resourceArn.");
    }
    let body;
    body = JSON.stringify({
        ...(input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_restJson1TagMap(input.Tags, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1TagResourceCommand = serializeAws_restJson1TagResourceCommand;
const serializeAws_restJson1UntagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{resourceArn}";
    if (input.resourceArn !== undefined) {
        const labelValue = input.resourceArn;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: resourceArn.");
        }
        resolvedPath = resolvedPath.replace("{resourceArn}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: resourceArn.");
    }
    const query = {
        ...(input.TagKeys !== undefined && { tagKeys: (input.TagKeys || []).map((_entry) => _entry) }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1UntagResourceCommand = serializeAws_restJson1UntagResourceCommand;
const deserializeAws_restJson1AssociateRepositoryCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1AssociateRepositoryCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        RepositoryAssociation: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.RepositoryAssociation !== undefined && data.RepositoryAssociation !== null) {
        contents.RepositoryAssociation = deserializeAws_restJson1RepositoryAssociation(data.RepositoryAssociation, context);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1AssociateRepositoryCommand = deserializeAws_restJson1AssociateRepositoryCommand;
const deserializeAws_restJson1AssociateRepositoryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.codegurureviewer#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1CreateCodeReviewCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1CreateCodeReviewCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        CodeReview: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.CodeReview !== undefined && data.CodeReview !== null) {
        contents.CodeReview = deserializeAws_restJson1CodeReview(data.CodeReview, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1CreateCodeReviewCommand = deserializeAws_restJson1CreateCodeReviewCommand;
const deserializeAws_restJson1CreateCodeReviewCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.codegurureviewer#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.codegurureviewer#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeCodeReviewCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeCodeReviewCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        CodeReview: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.CodeReview !== undefined && data.CodeReview !== null) {
        contents.CodeReview = deserializeAws_restJson1CodeReview(data.CodeReview, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeCodeReviewCommand = deserializeAws_restJson1DescribeCodeReviewCommand;
const deserializeAws_restJson1DescribeCodeReviewCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.codegurureviewer#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeRecommendationFeedbackCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeRecommendationFeedbackCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        RecommendationFeedback: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.RecommendationFeedback !== undefined && data.RecommendationFeedback !== null) {
        contents.RecommendationFeedback = deserializeAws_restJson1RecommendationFeedback(data.RecommendationFeedback, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeRecommendationFeedbackCommand = deserializeAws_restJson1DescribeRecommendationFeedbackCommand;
const deserializeAws_restJson1DescribeRecommendationFeedbackCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.codegurureviewer#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeRepositoryAssociationCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeRepositoryAssociationCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        RepositoryAssociation: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.RepositoryAssociation !== undefined && data.RepositoryAssociation !== null) {
        contents.RepositoryAssociation = deserializeAws_restJson1RepositoryAssociation(data.RepositoryAssociation, context);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeRepositoryAssociationCommand = deserializeAws_restJson1DescribeRepositoryAssociationCommand;
const deserializeAws_restJson1DescribeRepositoryAssociationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.codegurureviewer#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DisassociateRepositoryCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DisassociateRepositoryCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        RepositoryAssociation: undefined,
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.RepositoryAssociation !== undefined && data.RepositoryAssociation !== null) {
        contents.RepositoryAssociation = deserializeAws_restJson1RepositoryAssociation(data.RepositoryAssociation, context);
    }
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DisassociateRepositoryCommand = deserializeAws_restJson1DisassociateRepositoryCommand;
const deserializeAws_restJson1DisassociateRepositoryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.codegurureviewer#ConflictException":
            throw await deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "NotFoundException":
        case "com.amazonaws.codegurureviewer#NotFoundException":
            throw await deserializeAws_restJson1NotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListCodeReviewsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListCodeReviewsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        CodeReviewSummaries: undefined,
        NextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.CodeReviewSummaries !== undefined && data.CodeReviewSummaries !== null) {
        contents.CodeReviewSummaries = deserializeAws_restJson1CodeReviewSummaries(data.CodeReviewSummaries, context);
    }
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListCodeReviewsCommand = deserializeAws_restJson1ListCodeReviewsCommand;
const deserializeAws_restJson1ListCodeReviewsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListRecommendationFeedbackCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListRecommendationFeedbackCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        RecommendationFeedbackSummaries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.RecommendationFeedbackSummaries !== undefined && data.RecommendationFeedbackSummaries !== null) {
        contents.RecommendationFeedbackSummaries = deserializeAws_restJson1RecommendationFeedbackSummaries(data.RecommendationFeedbackSummaries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListRecommendationFeedbackCommand = deserializeAws_restJson1ListRecommendationFeedbackCommand;
const deserializeAws_restJson1ListRecommendationFeedbackCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.codegurureviewer#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListRecommendationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListRecommendationsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        RecommendationSummaries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.RecommendationSummaries !== undefined && data.RecommendationSummaries !== null) {
        contents.RecommendationSummaries = deserializeAws_restJson1RecommendationSummaries(data.RecommendationSummaries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListRecommendationsCommand = deserializeAws_restJson1ListRecommendationsCommand;
const deserializeAws_restJson1ListRecommendationsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.codegurureviewer#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListRepositoryAssociationsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListRepositoryAssociationsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        NextToken: undefined,
        RepositoryAssociationSummaries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.NextToken !== undefined && data.NextToken !== null) {
        contents.NextToken = (0, smithy_client_1.expectString)(data.NextToken);
    }
    if (data.RepositoryAssociationSummaries !== undefined && data.RepositoryAssociationSummaries !== null) {
        contents.RepositoryAssociationSummaries = deserializeAws_restJson1RepositoryAssociationSummaries(data.RepositoryAssociationSummaries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListRepositoryAssociationsCommand = deserializeAws_restJson1ListRepositoryAssociationsCommand;
const deserializeAws_restJson1ListRepositoryAssociationsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListTagsForResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        Tags: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.Tags !== undefined && data.Tags !== null) {
        contents.Tags = deserializeAws_restJson1TagMap(data.Tags, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListTagsForResourceCommand = deserializeAws_restJson1ListTagsForResourceCommand;
const deserializeAws_restJson1ListTagsForResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.codegurureviewer#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1PutRecommendationFeedbackCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1PutRecommendationFeedbackCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1PutRecommendationFeedbackCommand = deserializeAws_restJson1PutRecommendationFeedbackCommand;
const deserializeAws_restJson1PutRecommendationFeedbackCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.codegurureviewer#AccessDeniedException":
            throw await deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.codegurureviewer#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.codegurureviewer#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1TagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1TagResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1TagResourceCommand = deserializeAws_restJson1TagResourceCommand;
const deserializeAws_restJson1TagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.codegurureviewer#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1UntagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1UntagResourceCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
    };
    await collectBody(output.body, context);
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1UntagResourceCommand = deserializeAws_restJson1UntagResourceCommand;
const deserializeAws_restJson1UntagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServerException":
        case "com.amazonaws.codegurureviewer#InternalServerException":
            throw await deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.codegurureviewer#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.codegurureviewer#ValidationException":
            throw await deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new CodeGuruReviewerServiceException_1.CodeGuruReviewerServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1AccessDeniedExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.AccessDeniedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ConflictExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.ConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1InternalServerExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.InternalServerException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1NotFoundExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.NotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ResourceNotFoundExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ThrottlingExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.ThrottlingException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ValidationExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.Message !== undefined && data.Message !== null) {
        contents.Message = (0, smithy_client_1.expectString)(data.Message);
    }
    const exception = new models_0_1.ValidationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const serializeAws_restJson1AnalysisTypes = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1BranchDiffSourceCodeType = (input, context) => {
    return {
        ...(input.DestinationBranchName !== undefined &&
            input.DestinationBranchName !== null && { DestinationBranchName: input.DestinationBranchName }),
        ...(input.SourceBranchName !== undefined &&
            input.SourceBranchName !== null && { SourceBranchName: input.SourceBranchName }),
    };
};
const serializeAws_restJson1CodeArtifacts = (input, context) => {
    return {
        ...(input.BuildArtifactsObjectKey !== undefined &&
            input.BuildArtifactsObjectKey !== null && { BuildArtifactsObjectKey: input.BuildArtifactsObjectKey }),
        ...(input.SourceCodeArtifactsObjectKey !== undefined &&
            input.SourceCodeArtifactsObjectKey !== null && {
            SourceCodeArtifactsObjectKey: input.SourceCodeArtifactsObjectKey,
        }),
    };
};
const serializeAws_restJson1CodeCommitRepository = (input, context) => {
    return {
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
    };
};
const serializeAws_restJson1CodeReviewType = (input, context) => {
    return {
        ...(input.AnalysisTypes !== undefined &&
            input.AnalysisTypes !== null && {
            AnalysisTypes: serializeAws_restJson1AnalysisTypes(input.AnalysisTypes, context),
        }),
        ...(input.RepositoryAnalysis !== undefined &&
            input.RepositoryAnalysis !== null && {
            RepositoryAnalysis: serializeAws_restJson1RepositoryAnalysis(input.RepositoryAnalysis, context),
        }),
    };
};
const serializeAws_restJson1CommitDiffSourceCodeType = (input, context) => {
    return {
        ...(input.DestinationCommit !== undefined &&
            input.DestinationCommit !== null && { DestinationCommit: input.DestinationCommit }),
        ...(input.MergeBaseCommit !== undefined &&
            input.MergeBaseCommit !== null && { MergeBaseCommit: input.MergeBaseCommit }),
        ...(input.SourceCommit !== undefined && input.SourceCommit !== null && { SourceCommit: input.SourceCommit }),
    };
};
const serializeAws_restJson1EventInfo = (input, context) => {
    return {
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
        ...(input.State !== undefined && input.State !== null && { State: input.State }),
    };
};
const serializeAws_restJson1KMSKeyDetails = (input, context) => {
    return {
        ...(input.EncryptionOption !== undefined &&
            input.EncryptionOption !== null && { EncryptionOption: input.EncryptionOption }),
        ...(input.KMSKeyId !== undefined && input.KMSKeyId !== null && { KMSKeyId: input.KMSKeyId }),
    };
};
const serializeAws_restJson1Reactions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
const serializeAws_restJson1Repository = (input, context) => {
    return {
        ...(input.Bitbucket !== undefined &&
            input.Bitbucket !== null && {
            Bitbucket: serializeAws_restJson1ThirdPartySourceRepository(input.Bitbucket, context),
        }),
        ...(input.CodeCommit !== undefined &&
            input.CodeCommit !== null && {
            CodeCommit: serializeAws_restJson1CodeCommitRepository(input.CodeCommit, context),
        }),
        ...(input.GitHubEnterpriseServer !== undefined &&
            input.GitHubEnterpriseServer !== null && {
            GitHubEnterpriseServer: serializeAws_restJson1ThirdPartySourceRepository(input.GitHubEnterpriseServer, context),
        }),
        ...(input.S3Bucket !== undefined &&
            input.S3Bucket !== null && { S3Bucket: serializeAws_restJson1S3Repository(input.S3Bucket, context) }),
    };
};
const serializeAws_restJson1RepositoryAnalysis = (input, context) => {
    return {
        ...(input.RepositoryHead !== undefined &&
            input.RepositoryHead !== null && {
            RepositoryHead: serializeAws_restJson1RepositoryHeadSourceCodeType(input.RepositoryHead, context),
        }),
        ...(input.SourceCodeType !== undefined &&
            input.SourceCodeType !== null && {
            SourceCodeType: serializeAws_restJson1SourceCodeType(input.SourceCodeType, context),
        }),
    };
};
const serializeAws_restJson1RepositoryHeadSourceCodeType = (input, context) => {
    return {
        ...(input.BranchName !== undefined && input.BranchName !== null && { BranchName: input.BranchName }),
    };
};
const serializeAws_restJson1RequestMetadata = (input, context) => {
    return {
        ...(input.EventInfo !== undefined &&
            input.EventInfo !== null && { EventInfo: serializeAws_restJson1EventInfo(input.EventInfo, context) }),
        ...(input.RequestId !== undefined && input.RequestId !== null && { RequestId: input.RequestId }),
        ...(input.Requester !== undefined && input.Requester !== null && { Requester: input.Requester }),
        ...(input.VendorName !== undefined && input.VendorName !== null && { VendorName: input.VendorName }),
    };
};
const serializeAws_restJson1S3BucketRepository = (input, context) => {
    return {
        ...(input.Details !== undefined &&
            input.Details !== null && { Details: serializeAws_restJson1S3RepositoryDetails(input.Details, context) }),
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
    };
};
const serializeAws_restJson1S3Repository = (input, context) => {
    return {
        ...(input.BucketName !== undefined && input.BucketName !== null && { BucketName: input.BucketName }),
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
    };
};
const serializeAws_restJson1S3RepositoryDetails = (input, context) => {
    return {
        ...(input.BucketName !== undefined && input.BucketName !== null && { BucketName: input.BucketName }),
        ...(input.CodeArtifacts !== undefined &&
            input.CodeArtifacts !== null && {
            CodeArtifacts: serializeAws_restJson1CodeArtifacts(input.CodeArtifacts, context),
        }),
    };
};
const serializeAws_restJson1SourceCodeType = (input, context) => {
    return {
        ...(input.BranchDiff !== undefined &&
            input.BranchDiff !== null && {
            BranchDiff: serializeAws_restJson1BranchDiffSourceCodeType(input.BranchDiff, context),
        }),
        ...(input.CommitDiff !== undefined &&
            input.CommitDiff !== null && {
            CommitDiff: serializeAws_restJson1CommitDiffSourceCodeType(input.CommitDiff, context),
        }),
        ...(input.RepositoryHead !== undefined &&
            input.RepositoryHead !== null && {
            RepositoryHead: serializeAws_restJson1RepositoryHeadSourceCodeType(input.RepositoryHead, context),
        }),
        ...(input.RequestMetadata !== undefined &&
            input.RequestMetadata !== null && {
            RequestMetadata: serializeAws_restJson1RequestMetadata(input.RequestMetadata, context),
        }),
        ...(input.S3BucketRepository !== undefined &&
            input.S3BucketRepository !== null && {
            S3BucketRepository: serializeAws_restJson1S3BucketRepository(input.S3BucketRepository, context),
        }),
    };
};
const serializeAws_restJson1TagMap = (input, context) => {
    return Object.entries(input).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: value,
        };
    }, {});
};
const serializeAws_restJson1ThirdPartySourceRepository = (input, context) => {
    return {
        ...(input.ConnectionArn !== undefined && input.ConnectionArn !== null && { ConnectionArn: input.ConnectionArn }),
        ...(input.Name !== undefined && input.Name !== null && { Name: input.Name }),
        ...(input.Owner !== undefined && input.Owner !== null && { Owner: input.Owner }),
    };
};
const deserializeAws_restJson1AnalysisTypes = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1BranchDiffSourceCodeType = (output, context) => {
    return {
        DestinationBranchName: (0, smithy_client_1.expectString)(output.DestinationBranchName),
        SourceBranchName: (0, smithy_client_1.expectString)(output.SourceBranchName),
    };
};
const deserializeAws_restJson1CodeArtifacts = (output, context) => {
    return {
        BuildArtifactsObjectKey: (0, smithy_client_1.expectString)(output.BuildArtifactsObjectKey),
        SourceCodeArtifactsObjectKey: (0, smithy_client_1.expectString)(output.SourceCodeArtifactsObjectKey),
    };
};
const deserializeAws_restJson1CodeReview = (output, context) => {
    return {
        AnalysisTypes: output.AnalysisTypes !== undefined && output.AnalysisTypes !== null
            ? deserializeAws_restJson1AnalysisTypes(output.AnalysisTypes, context)
            : undefined,
        AssociationArn: (0, smithy_client_1.expectString)(output.AssociationArn),
        CodeReviewArn: (0, smithy_client_1.expectString)(output.CodeReviewArn),
        CreatedTimeStamp: output.CreatedTimeStamp !== undefined && output.CreatedTimeStamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreatedTimeStamp)))
            : undefined,
        LastUpdatedTimeStamp: output.LastUpdatedTimeStamp !== undefined && output.LastUpdatedTimeStamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTimeStamp)))
            : undefined,
        Metrics: output.Metrics !== undefined && output.Metrics !== null
            ? deserializeAws_restJson1Metrics(output.Metrics, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        Owner: (0, smithy_client_1.expectString)(output.Owner),
        ProviderType: (0, smithy_client_1.expectString)(output.ProviderType),
        PullRequestId: (0, smithy_client_1.expectString)(output.PullRequestId),
        RepositoryName: (0, smithy_client_1.expectString)(output.RepositoryName),
        SourceCodeType: output.SourceCodeType !== undefined && output.SourceCodeType !== null
            ? deserializeAws_restJson1SourceCodeType(output.SourceCodeType, context)
            : undefined,
        State: (0, smithy_client_1.expectString)(output.State),
        StateReason: (0, smithy_client_1.expectString)(output.StateReason),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_restJson1CodeReviewSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1CodeReviewSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1CodeReviewSummary = (output, context) => {
    return {
        CodeReviewArn: (0, smithy_client_1.expectString)(output.CodeReviewArn),
        CreatedTimeStamp: output.CreatedTimeStamp !== undefined && output.CreatedTimeStamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreatedTimeStamp)))
            : undefined,
        LastUpdatedTimeStamp: output.LastUpdatedTimeStamp !== undefined && output.LastUpdatedTimeStamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTimeStamp)))
            : undefined,
        MetricsSummary: output.MetricsSummary !== undefined && output.MetricsSummary !== null
            ? deserializeAws_restJson1MetricsSummary(output.MetricsSummary, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        Owner: (0, smithy_client_1.expectString)(output.Owner),
        ProviderType: (0, smithy_client_1.expectString)(output.ProviderType),
        PullRequestId: (0, smithy_client_1.expectString)(output.PullRequestId),
        RepositoryName: (0, smithy_client_1.expectString)(output.RepositoryName),
        SourceCodeType: output.SourceCodeType !== undefined && output.SourceCodeType !== null
            ? deserializeAws_restJson1SourceCodeType(output.SourceCodeType, context)
            : undefined,
        State: (0, smithy_client_1.expectString)(output.State),
        Type: (0, smithy_client_1.expectString)(output.Type),
    };
};
const deserializeAws_restJson1CommitDiffSourceCodeType = (output, context) => {
    return {
        DestinationCommit: (0, smithy_client_1.expectString)(output.DestinationCommit),
        MergeBaseCommit: (0, smithy_client_1.expectString)(output.MergeBaseCommit),
        SourceCommit: (0, smithy_client_1.expectString)(output.SourceCommit),
    };
};
const deserializeAws_restJson1EventInfo = (output, context) => {
    return {
        Name: (0, smithy_client_1.expectString)(output.Name),
        State: (0, smithy_client_1.expectString)(output.State),
    };
};
const deserializeAws_restJson1KMSKeyDetails = (output, context) => {
    return {
        EncryptionOption: (0, smithy_client_1.expectString)(output.EncryptionOption),
        KMSKeyId: (0, smithy_client_1.expectString)(output.KMSKeyId),
    };
};
const deserializeAws_restJson1Metrics = (output, context) => {
    return {
        FindingsCount: (0, smithy_client_1.expectLong)(output.FindingsCount),
        MeteredLinesOfCodeCount: (0, smithy_client_1.expectLong)(output.MeteredLinesOfCodeCount),
    };
};
const deserializeAws_restJson1MetricsSummary = (output, context) => {
    return {
        FindingsCount: (0, smithy_client_1.expectLong)(output.FindingsCount),
        MeteredLinesOfCodeCount: (0, smithy_client_1.expectLong)(output.MeteredLinesOfCodeCount),
    };
};
const deserializeAws_restJson1Reactions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1RecommendationFeedback = (output, context) => {
    return {
        CodeReviewArn: (0, smithy_client_1.expectString)(output.CodeReviewArn),
        CreatedTimeStamp: output.CreatedTimeStamp !== undefined && output.CreatedTimeStamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreatedTimeStamp)))
            : undefined,
        LastUpdatedTimeStamp: output.LastUpdatedTimeStamp !== undefined && output.LastUpdatedTimeStamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTimeStamp)))
            : undefined,
        Reactions: output.Reactions !== undefined && output.Reactions !== null
            ? deserializeAws_restJson1Reactions(output.Reactions, context)
            : undefined,
        RecommendationId: (0, smithy_client_1.expectString)(output.RecommendationId),
        UserId: (0, smithy_client_1.expectString)(output.UserId),
    };
};
const deserializeAws_restJson1RecommendationFeedbackSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RecommendationFeedbackSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RecommendationFeedbackSummary = (output, context) => {
    return {
        Reactions: output.Reactions !== undefined && output.Reactions !== null
            ? deserializeAws_restJson1Reactions(output.Reactions, context)
            : undefined,
        RecommendationId: (0, smithy_client_1.expectString)(output.RecommendationId),
        UserId: (0, smithy_client_1.expectString)(output.UserId),
    };
};
const deserializeAws_restJson1RecommendationSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RecommendationSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RecommendationSummary = (output, context) => {
    return {
        Description: (0, smithy_client_1.expectString)(output.Description),
        EndLine: (0, smithy_client_1.expectInt32)(output.EndLine),
        FilePath: (0, smithy_client_1.expectString)(output.FilePath),
        RecommendationCategory: (0, smithy_client_1.expectString)(output.RecommendationCategory),
        RecommendationId: (0, smithy_client_1.expectString)(output.RecommendationId),
        RuleMetadata: output.RuleMetadata !== undefined && output.RuleMetadata !== null
            ? deserializeAws_restJson1RuleMetadata(output.RuleMetadata, context)
            : undefined,
        Severity: (0, smithy_client_1.expectString)(output.Severity),
        StartLine: (0, smithy_client_1.expectInt32)(output.StartLine),
    };
};
const deserializeAws_restJson1RepositoryAssociation = (output, context) => {
    return {
        AssociationArn: (0, smithy_client_1.expectString)(output.AssociationArn),
        AssociationId: (0, smithy_client_1.expectString)(output.AssociationId),
        ConnectionArn: (0, smithy_client_1.expectString)(output.ConnectionArn),
        CreatedTimeStamp: output.CreatedTimeStamp !== undefined && output.CreatedTimeStamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.CreatedTimeStamp)))
            : undefined,
        KMSKeyDetails: output.KMSKeyDetails !== undefined && output.KMSKeyDetails !== null
            ? deserializeAws_restJson1KMSKeyDetails(output.KMSKeyDetails, context)
            : undefined,
        LastUpdatedTimeStamp: output.LastUpdatedTimeStamp !== undefined && output.LastUpdatedTimeStamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTimeStamp)))
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        Owner: (0, smithy_client_1.expectString)(output.Owner),
        ProviderType: (0, smithy_client_1.expectString)(output.ProviderType),
        S3RepositoryDetails: output.S3RepositoryDetails !== undefined && output.S3RepositoryDetails !== null
            ? deserializeAws_restJson1S3RepositoryDetails(output.S3RepositoryDetails, context)
            : undefined,
        State: (0, smithy_client_1.expectString)(output.State),
        StateReason: (0, smithy_client_1.expectString)(output.StateReason),
    };
};
const deserializeAws_restJson1RepositoryAssociationSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RepositoryAssociationSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1RepositoryAssociationSummary = (output, context) => {
    return {
        AssociationArn: (0, smithy_client_1.expectString)(output.AssociationArn),
        AssociationId: (0, smithy_client_1.expectString)(output.AssociationId),
        ConnectionArn: (0, smithy_client_1.expectString)(output.ConnectionArn),
        LastUpdatedTimeStamp: output.LastUpdatedTimeStamp !== undefined && output.LastUpdatedTimeStamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.LastUpdatedTimeStamp)))
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
        Owner: (0, smithy_client_1.expectString)(output.Owner),
        ProviderType: (0, smithy_client_1.expectString)(output.ProviderType),
        State: (0, smithy_client_1.expectString)(output.State),
    };
};
const deserializeAws_restJson1RepositoryHeadSourceCodeType = (output, context) => {
    return {
        BranchName: (0, smithy_client_1.expectString)(output.BranchName),
    };
};
const deserializeAws_restJson1RequestMetadata = (output, context) => {
    return {
        EventInfo: output.EventInfo !== undefined && output.EventInfo !== null
            ? deserializeAws_restJson1EventInfo(output.EventInfo, context)
            : undefined,
        RequestId: (0, smithy_client_1.expectString)(output.RequestId),
        Requester: (0, smithy_client_1.expectString)(output.Requester),
        VendorName: (0, smithy_client_1.expectString)(output.VendorName),
    };
};
const deserializeAws_restJson1RuleMetadata = (output, context) => {
    return {
        LongDescription: (0, smithy_client_1.expectString)(output.LongDescription),
        RuleId: (0, smithy_client_1.expectString)(output.RuleId),
        RuleName: (0, smithy_client_1.expectString)(output.RuleName),
        RuleTags: output.RuleTags !== undefined && output.RuleTags !== null
            ? deserializeAws_restJson1RuleTags(output.RuleTags, context)
            : undefined,
        ShortDescription: (0, smithy_client_1.expectString)(output.ShortDescription),
    };
};
const deserializeAws_restJson1RuleTags = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return (0, smithy_client_1.expectString)(entry);
    });
    return retVal;
};
const deserializeAws_restJson1S3BucketRepository = (output, context) => {
    return {
        Details: output.Details !== undefined && output.Details !== null
            ? deserializeAws_restJson1S3RepositoryDetails(output.Details, context)
            : undefined,
        Name: (0, smithy_client_1.expectString)(output.Name),
    };
};
const deserializeAws_restJson1S3RepositoryDetails = (output, context) => {
    return {
        BucketName: (0, smithy_client_1.expectString)(output.BucketName),
        CodeArtifacts: output.CodeArtifacts !== undefined && output.CodeArtifacts !== null
            ? deserializeAws_restJson1CodeArtifacts(output.CodeArtifacts, context)
            : undefined,
    };
};
const deserializeAws_restJson1SourceCodeType = (output, context) => {
    return {
        BranchDiff: output.BranchDiff !== undefined && output.BranchDiff !== null
            ? deserializeAws_restJson1BranchDiffSourceCodeType(output.BranchDiff, context)
            : undefined,
        CommitDiff: output.CommitDiff !== undefined && output.CommitDiff !== null
            ? deserializeAws_restJson1CommitDiffSourceCodeType(output.CommitDiff, context)
            : undefined,
        RepositoryHead: output.RepositoryHead !== undefined && output.RepositoryHead !== null
            ? deserializeAws_restJson1RepositoryHeadSourceCodeType(output.RepositoryHead, context)
            : undefined,
        RequestMetadata: output.RequestMetadata !== undefined && output.RequestMetadata !== null
            ? deserializeAws_restJson1RequestMetadata(output.RequestMetadata, context)
            : undefined,
        S3BucketRepository: output.S3BucketRepository !== undefined && output.S3BucketRepository !== null
            ? deserializeAws_restJson1S3BucketRepository(output.S3BucketRepository, context)
            : undefined,
    };
};
const deserializeAws_restJson1TagMap = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: (0, smithy_client_1.expectString)(value),
        };
    }, {});
};
const deserializeMetadata = (output) => {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const isSerializableHeaderValue = (value) => value !== undefined &&
    value !== null &&
    value !== "" &&
    (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
    (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
