"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitUntilCodeReviewCompleted = exports.waitForCodeReviewCompleted = void 0;
const util_waiter_1 = require("@aws-sdk/util-waiter");
const DescribeCodeReviewCommand_1 = require("../commands/DescribeCodeReviewCommand");
const checkState = async (client, input) => {
    let reason;
    try {
        const result = await client.send(new DescribeCodeReviewCommand_1.DescribeCodeReviewCommand(input));
        reason = result;
        try {
            const returnComparator = () => {
                return result.CodeReview.State;
            };
            if (returnComparator() === "Completed") {
                return { state: util_waiter_1.WaiterState.SUCCESS, reason };
            }
        }
        catch (e) { }
        try {
            const returnComparator = () => {
                return result.CodeReview.State;
            };
            if (returnComparator() === "Failed") {
                return { state: util_waiter_1.WaiterState.FAILURE, reason };
            }
        }
        catch (e) { }
        try {
            const returnComparator = () => {
                return result.CodeReview.State;
            };
            if (returnComparator() === "Pending") {
                return { state: util_waiter_1.WaiterState.RETRY, reason };
            }
        }
        catch (e) { }
    }
    catch (exception) {
        reason = exception;
    }
    return { state: util_waiter_1.WaiterState.RETRY, reason };
};
const waitForCodeReviewCompleted = async (params, input) => {
    const serviceDefaults = { minDelay: 10, maxDelay: 120 };
    return (0, util_waiter_1.createWaiter)({ ...serviceDefaults, ...params }, input, checkState);
};
exports.waitForCodeReviewCompleted = waitForCodeReviewCompleted;
const waitUntilCodeReviewCompleted = async (params, input) => {
    const serviceDefaults = { minDelay: 10, maxDelay: 120 };
    const result = await (0, util_waiter_1.createWaiter)({ ...serviceDefaults, ...params }, input, checkState);
    return (0, util_waiter_1.checkExceptions)(result);
};
exports.waitUntilCodeReviewCompleted = waitUntilCodeReviewCompleted;
