import { __extends } from "tslib";
import { CodeGuruReviewerClient } from "./CodeGuruReviewerClient";
import { AssociateRepositoryCommand, } from "./commands/AssociateRepositoryCommand";
import { CreateCodeReviewCommand, } from "./commands/CreateCodeReviewCommand";
import { DescribeCodeReviewCommand, } from "./commands/DescribeCodeReviewCommand";
import { DescribeRecommendationFeedbackCommand, } from "./commands/DescribeRecommendationFeedbackCommand";
import { DescribeRepositoryAssociationCommand, } from "./commands/DescribeRepositoryAssociationCommand";
import { DisassociateRepositoryCommand, } from "./commands/DisassociateRepositoryCommand";
import { ListCodeReviewsCommand, } from "./commands/ListCodeReviewsCommand";
import { ListRecommendationFeedbackCommand, } from "./commands/ListRecommendationFeedbackCommand";
import { ListRecommendationsCommand, } from "./commands/ListRecommendationsCommand";
import { ListRepositoryAssociationsCommand, } from "./commands/ListRepositoryAssociationsCommand";
import { ListTagsForResourceCommand, } from "./commands/ListTagsForResourceCommand";
import { PutRecommendationFeedbackCommand, } from "./commands/PutRecommendationFeedbackCommand";
import { TagResourceCommand } from "./commands/TagResourceCommand";
import { UntagResourceCommand, } from "./commands/UntagResourceCommand";
var CodeGuruReviewer = (function (_super) {
    __extends(CodeGuruReviewer, _super);
    function CodeGuruReviewer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CodeGuruReviewer.prototype.associateRepository = function (args, optionsOrCb, cb) {
        var command = new AssociateRepositoryCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.createCodeReview = function (args, optionsOrCb, cb) {
        var command = new CreateCodeReviewCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.describeCodeReview = function (args, optionsOrCb, cb) {
        var command = new DescribeCodeReviewCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.describeRecommendationFeedback = function (args, optionsOrCb, cb) {
        var command = new DescribeRecommendationFeedbackCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.describeRepositoryAssociation = function (args, optionsOrCb, cb) {
        var command = new DescribeRepositoryAssociationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.disassociateRepository = function (args, optionsOrCb, cb) {
        var command = new DisassociateRepositoryCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.listCodeReviews = function (args, optionsOrCb, cb) {
        var command = new ListCodeReviewsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.listRecommendationFeedback = function (args, optionsOrCb, cb) {
        var command = new ListRecommendationFeedbackCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.listRecommendations = function (args, optionsOrCb, cb) {
        var command = new ListRecommendationsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.listRepositoryAssociations = function (args, optionsOrCb, cb) {
        var command = new ListRepositoryAssociationsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.listTagsForResource = function (args, optionsOrCb, cb) {
        var command = new ListTagsForResourceCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.putRecommendationFeedback = function (args, optionsOrCb, cb) {
        var command = new PutRecommendationFeedbackCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.tagResource = function (args, optionsOrCb, cb) {
        var command = new TagResourceCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    CodeGuruReviewer.prototype.untagResource = function (args, optionsOrCb, cb) {
        var command = new UntagResourceCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    return CodeGuruReviewer;
}(CodeGuruReviewerClient));
export { CodeGuruReviewer };
