import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { AssociateRepositoryRequest, AssociateRepositoryResponse } from "../models/models_0";
import { deserializeAws_restJson1AssociateRepositoryCommand, serializeAws_restJson1AssociateRepositoryCommand, } from "../protocols/Aws_restJson1";
var AssociateRepositoryCommand = (function (_super) {
    __extends(AssociateRepositoryCommand, _super);
    function AssociateRepositoryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    AssociateRepositoryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeGuruReviewerClient";
        var commandName = "AssociateRepositoryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: AssociateRepositoryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: AssociateRepositoryResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    AssociateRepositoryCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1AssociateRepositoryCommand(input, context);
    };
    AssociateRepositoryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1AssociateRepositoryCommand(output, context);
    };
    return AssociateRepositoryCommand;
}($Command));
export { AssociateRepositoryCommand };
