import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateCodeReviewRequest, CreateCodeReviewResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateCodeReviewCommand, serializeAws_restJson1CreateCodeReviewCommand, } from "../protocols/Aws_restJson1";
var CreateCodeReviewCommand = (function (_super) {
    __extends(CreateCodeReviewCommand, _super);
    function CreateCodeReviewCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateCodeReviewCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeGuruReviewerClient";
        var commandName = "CreateCodeReviewCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateCodeReviewRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateCodeReviewResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateCodeReviewCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateCodeReviewCommand(input, context);
    };
    CreateCodeReviewCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateCodeReviewCommand(output, context);
    };
    return CreateCodeReviewCommand;
}($Command));
export { CreateCodeReviewCommand };
