import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeCodeReviewRequest, DescribeCodeReviewResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribeCodeReviewCommand, serializeAws_restJson1DescribeCodeReviewCommand, } from "../protocols/Aws_restJson1";
var DescribeCodeReviewCommand = (function (_super) {
    __extends(DescribeCodeReviewCommand, _super);
    function DescribeCodeReviewCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeCodeReviewCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeGuruReviewerClient";
        var commandName = "DescribeCodeReviewCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeCodeReviewRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeCodeReviewResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeCodeReviewCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeCodeReviewCommand(input, context);
    };
    DescribeCodeReviewCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeCodeReviewCommand(output, context);
    };
    return DescribeCodeReviewCommand;
}($Command));
export { DescribeCodeReviewCommand };
