import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeRecommendationFeedbackRequest, DescribeRecommendationFeedbackResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribeRecommendationFeedbackCommand, serializeAws_restJson1DescribeRecommendationFeedbackCommand, } from "../protocols/Aws_restJson1";
var DescribeRecommendationFeedbackCommand = (function (_super) {
    __extends(DescribeRecommendationFeedbackCommand, _super);
    function DescribeRecommendationFeedbackCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeRecommendationFeedbackCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeGuruReviewerClient";
        var commandName = "DescribeRecommendationFeedbackCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeRecommendationFeedbackRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeRecommendationFeedbackResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeRecommendationFeedbackCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeRecommendationFeedbackCommand(input, context);
    };
    DescribeRecommendationFeedbackCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeRecommendationFeedbackCommand(output, context);
    };
    return DescribeRecommendationFeedbackCommand;
}($Command));
export { DescribeRecommendationFeedbackCommand };
