import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeRepositoryAssociationRequest, DescribeRepositoryAssociationResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribeRepositoryAssociationCommand, serializeAws_restJson1DescribeRepositoryAssociationCommand, } from "../protocols/Aws_restJson1";
var DescribeRepositoryAssociationCommand = (function (_super) {
    __extends(DescribeRepositoryAssociationCommand, _super);
    function DescribeRepositoryAssociationCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeRepositoryAssociationCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeGuruReviewerClient";
        var commandName = "DescribeRepositoryAssociationCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeRepositoryAssociationRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeRepositoryAssociationResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeRepositoryAssociationCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeRepositoryAssociationCommand(input, context);
    };
    DescribeRepositoryAssociationCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeRepositoryAssociationCommand(output, context);
    };
    return DescribeRepositoryAssociationCommand;
}($Command));
export { DescribeRepositoryAssociationCommand };
