import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListRecommendationFeedbackRequest, ListRecommendationFeedbackResponse } from "../models/models_0";
import { deserializeAws_restJson1ListRecommendationFeedbackCommand, serializeAws_restJson1ListRecommendationFeedbackCommand, } from "../protocols/Aws_restJson1";
var ListRecommendationFeedbackCommand = (function (_super) {
    __extends(ListRecommendationFeedbackCommand, _super);
    function ListRecommendationFeedbackCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListRecommendationFeedbackCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeGuruReviewerClient";
        var commandName = "ListRecommendationFeedbackCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListRecommendationFeedbackRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListRecommendationFeedbackResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListRecommendationFeedbackCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListRecommendationFeedbackCommand(input, context);
    };
    ListRecommendationFeedbackCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListRecommendationFeedbackCommand(output, context);
    };
    return ListRecommendationFeedbackCommand;
}($Command));
export { ListRecommendationFeedbackCommand };
