import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListRecommendationsRequest, ListRecommendationsResponse } from "../models/models_0";
import { deserializeAws_restJson1ListRecommendationsCommand, serializeAws_restJson1ListRecommendationsCommand, } from "../protocols/Aws_restJson1";
var ListRecommendationsCommand = (function (_super) {
    __extends(ListRecommendationsCommand, _super);
    function ListRecommendationsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListRecommendationsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeGuruReviewerClient";
        var commandName = "ListRecommendationsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListRecommendationsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListRecommendationsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListRecommendationsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListRecommendationsCommand(input, context);
    };
    ListRecommendationsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListRecommendationsCommand(output, context);
    };
    return ListRecommendationsCommand;
}($Command));
export { ListRecommendationsCommand };
