import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListRepositoryAssociationsRequest, ListRepositoryAssociationsResponse } from "../models/models_0";
import { deserializeAws_restJson1ListRepositoryAssociationsCommand, serializeAws_restJson1ListRepositoryAssociationsCommand, } from "../protocols/Aws_restJson1";
var ListRepositoryAssociationsCommand = (function (_super) {
    __extends(ListRepositoryAssociationsCommand, _super);
    function ListRepositoryAssociationsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListRepositoryAssociationsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeGuruReviewerClient";
        var commandName = "ListRepositoryAssociationsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListRepositoryAssociationsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListRepositoryAssociationsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListRepositoryAssociationsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListRepositoryAssociationsCommand(input, context);
    };
    ListRepositoryAssociationsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListRepositoryAssociationsCommand(output, context);
    };
    return ListRepositoryAssociationsCommand;
}($Command));
export { ListRepositoryAssociationsCommand };
