import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutRecommendationFeedbackRequest, PutRecommendationFeedbackResponse } from "../models/models_0";
import { deserializeAws_restJson1PutRecommendationFeedbackCommand, serializeAws_restJson1PutRecommendationFeedbackCommand, } from "../protocols/Aws_restJson1";
var PutRecommendationFeedbackCommand = (function (_super) {
    __extends(PutRecommendationFeedbackCommand, _super);
    function PutRecommendationFeedbackCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutRecommendationFeedbackCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeGuruReviewerClient";
        var commandName = "PutRecommendationFeedbackCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutRecommendationFeedbackRequest.filterSensitiveLog,
            outputFilterSensitiveLog: PutRecommendationFeedbackResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutRecommendationFeedbackCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1PutRecommendationFeedbackCommand(input, context);
    };
    PutRecommendationFeedbackCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1PutRecommendationFeedbackCommand(output, context);
    };
    return PutRecommendationFeedbackCommand;
}($Command));
export { PutRecommendationFeedbackCommand };
