import { __assign, __extends } from "tslib";
import { CodeGuruReviewerServiceException as __BaseException } from "./CodeGuruReviewerServiceException";
var AccessDeniedException = (function (_super) {
    __extends(AccessDeniedException, _super);
    function AccessDeniedException(opts) {
        var _this = _super.call(this, __assign({ name: "AccessDeniedException", $fault: "client" }, opts)) || this;
        _this.name = "AccessDeniedException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, AccessDeniedException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return AccessDeniedException;
}(__BaseException));
export { AccessDeniedException };
export var AnalysisType;
(function (AnalysisType) {
    AnalysisType["CODE_QUALITY"] = "CodeQuality";
    AnalysisType["SECURITY"] = "Security";
})(AnalysisType || (AnalysisType = {}));
export var EncryptionOption;
(function (EncryptionOption) {
    EncryptionOption["AoCmk"] = "AWS_OWNED_CMK";
    EncryptionOption["CmCmk"] = "CUSTOMER_MANAGED_CMK";
})(EncryptionOption || (EncryptionOption = {}));
export var KMSKeyDetails;
(function (KMSKeyDetails) {
    KMSKeyDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(KMSKeyDetails || (KMSKeyDetails = {}));
export var ThirdPartySourceRepository;
(function (ThirdPartySourceRepository) {
    ThirdPartySourceRepository.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ThirdPartySourceRepository || (ThirdPartySourceRepository = {}));
export var CodeCommitRepository;
(function (CodeCommitRepository) {
    CodeCommitRepository.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CodeCommitRepository || (CodeCommitRepository = {}));
export var S3Repository;
(function (S3Repository) {
    S3Repository.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(S3Repository || (S3Repository = {}));
export var Repository;
(function (Repository) {
    Repository.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Repository || (Repository = {}));
export var AssociateRepositoryRequest;
(function (AssociateRepositoryRequest) {
    AssociateRepositoryRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AssociateRepositoryRequest || (AssociateRepositoryRequest = {}));
export var ProviderType;
(function (ProviderType) {
    ProviderType["BITBUCKET"] = "Bitbucket";
    ProviderType["CODE_COMMIT"] = "CodeCommit";
    ProviderType["GIT_HUB"] = "GitHub";
    ProviderType["GIT_HUB_ENTERPRISE_SERVER"] = "GitHubEnterpriseServer";
    ProviderType["S3_BUCKET"] = "S3Bucket";
})(ProviderType || (ProviderType = {}));
export var CodeArtifacts;
(function (CodeArtifacts) {
    CodeArtifacts.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CodeArtifacts || (CodeArtifacts = {}));
export var S3RepositoryDetails;
(function (S3RepositoryDetails) {
    S3RepositoryDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(S3RepositoryDetails || (S3RepositoryDetails = {}));
export var RepositoryAssociationState;
(function (RepositoryAssociationState) {
    RepositoryAssociationState["ASSOCIATED"] = "Associated";
    RepositoryAssociationState["ASSOCIATING"] = "Associating";
    RepositoryAssociationState["DISASSOCIATED"] = "Disassociated";
    RepositoryAssociationState["DISASSOCIATING"] = "Disassociating";
    RepositoryAssociationState["FAILED"] = "Failed";
})(RepositoryAssociationState || (RepositoryAssociationState = {}));
export var RepositoryAssociation;
(function (RepositoryAssociation) {
    RepositoryAssociation.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RepositoryAssociation || (RepositoryAssociation = {}));
export var AssociateRepositoryResponse;
(function (AssociateRepositoryResponse) {
    AssociateRepositoryResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AssociateRepositoryResponse || (AssociateRepositoryResponse = {}));
var ConflictException = (function (_super) {
    __extends(ConflictException, _super);
    function ConflictException(opts) {
        var _this = _super.call(this, __assign({ name: "ConflictException", $fault: "client" }, opts)) || this;
        _this.name = "ConflictException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ConflictException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ConflictException;
}(__BaseException));
export { ConflictException };
var InternalServerException = (function (_super) {
    __extends(InternalServerException, _super);
    function InternalServerException(opts) {
        var _this = _super.call(this, __assign({ name: "InternalServerException", $fault: "server" }, opts)) || this;
        _this.name = "InternalServerException";
        _this.$fault = "server";
        Object.setPrototypeOf(_this, InternalServerException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return InternalServerException;
}(__BaseException));
export { InternalServerException };
var ThrottlingException = (function (_super) {
    __extends(ThrottlingException, _super);
    function ThrottlingException(opts) {
        var _this = _super.call(this, __assign({ name: "ThrottlingException", $fault: "client" }, opts)) || this;
        _this.name = "ThrottlingException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ThrottlingException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ThrottlingException;
}(__BaseException));
export { ThrottlingException };
var ValidationException = (function (_super) {
    __extends(ValidationException, _super);
    function ValidationException(opts) {
        var _this = _super.call(this, __assign({ name: "ValidationException", $fault: "client" }, opts)) || this;
        _this.name = "ValidationException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ValidationException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ValidationException;
}(__BaseException));
export { ValidationException };
export var RepositoryHeadSourceCodeType;
(function (RepositoryHeadSourceCodeType) {
    RepositoryHeadSourceCodeType.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RepositoryHeadSourceCodeType || (RepositoryHeadSourceCodeType = {}));
export var BranchDiffSourceCodeType;
(function (BranchDiffSourceCodeType) {
    BranchDiffSourceCodeType.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(BranchDiffSourceCodeType || (BranchDiffSourceCodeType = {}));
export var CommitDiffSourceCodeType;
(function (CommitDiffSourceCodeType) {
    CommitDiffSourceCodeType.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CommitDiffSourceCodeType || (CommitDiffSourceCodeType = {}));
export var EventInfo;
(function (EventInfo) {
    EventInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(EventInfo || (EventInfo = {}));
export var VendorName;
(function (VendorName) {
    VendorName["GITHUB"] = "GitHub";
    VendorName["GITLAB"] = "GitLab";
    VendorName["NATIVE_S3"] = "NativeS3";
})(VendorName || (VendorName = {}));
export var RequestMetadata;
(function (RequestMetadata) {
    RequestMetadata.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RequestMetadata || (RequestMetadata = {}));
export var S3BucketRepository;
(function (S3BucketRepository) {
    S3BucketRepository.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(S3BucketRepository || (S3BucketRepository = {}));
export var SourceCodeType;
(function (SourceCodeType) {
    SourceCodeType.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(SourceCodeType || (SourceCodeType = {}));
export var RepositoryAnalysis;
(function (RepositoryAnalysis) {
    RepositoryAnalysis.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RepositoryAnalysis || (RepositoryAnalysis = {}));
export var CodeReviewType;
(function (CodeReviewType) {
    CodeReviewType.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CodeReviewType || (CodeReviewType = {}));
export var CreateCodeReviewRequest;
(function (CreateCodeReviewRequest) {
    CreateCodeReviewRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateCodeReviewRequest || (CreateCodeReviewRequest = {}));
export var Metrics;
(function (Metrics) {
    Metrics.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Metrics || (Metrics = {}));
export var JobState;
(function (JobState) {
    JobState["COMPLETED"] = "Completed";
    JobState["DELETING"] = "Deleting";
    JobState["FAILED"] = "Failed";
    JobState["PENDING"] = "Pending";
})(JobState || (JobState = {}));
export var Type;
(function (Type) {
    Type["PULL_REQUEST"] = "PullRequest";
    Type["REPOSITORY_ANALYSIS"] = "RepositoryAnalysis";
})(Type || (Type = {}));
export var CodeReview;
(function (CodeReview) {
    CodeReview.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CodeReview || (CodeReview = {}));
export var CreateCodeReviewResponse;
(function (CreateCodeReviewResponse) {
    CreateCodeReviewResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateCodeReviewResponse || (CreateCodeReviewResponse = {}));
var ResourceNotFoundException = (function (_super) {
    __extends(ResourceNotFoundException, _super);
    function ResourceNotFoundException(opts) {
        var _this = _super.call(this, __assign({ name: "ResourceNotFoundException", $fault: "client" }, opts)) || this;
        _this.name = "ResourceNotFoundException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ResourceNotFoundException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ResourceNotFoundException;
}(__BaseException));
export { ResourceNotFoundException };
export var DescribeCodeReviewRequest;
(function (DescribeCodeReviewRequest) {
    DescribeCodeReviewRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeCodeReviewRequest || (DescribeCodeReviewRequest = {}));
export var DescribeCodeReviewResponse;
(function (DescribeCodeReviewResponse) {
    DescribeCodeReviewResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeCodeReviewResponse || (DescribeCodeReviewResponse = {}));
export var DescribeRecommendationFeedbackRequest;
(function (DescribeRecommendationFeedbackRequest) {
    DescribeRecommendationFeedbackRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeRecommendationFeedbackRequest || (DescribeRecommendationFeedbackRequest = {}));
export var Reaction;
(function (Reaction) {
    Reaction["THUMBS_DOWN"] = "ThumbsDown";
    Reaction["THUMBS_UP"] = "ThumbsUp";
})(Reaction || (Reaction = {}));
export var RecommendationFeedback;
(function (RecommendationFeedback) {
    RecommendationFeedback.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RecommendationFeedback || (RecommendationFeedback = {}));
export var DescribeRecommendationFeedbackResponse;
(function (DescribeRecommendationFeedbackResponse) {
    DescribeRecommendationFeedbackResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeRecommendationFeedbackResponse || (DescribeRecommendationFeedbackResponse = {}));
export var DescribeRepositoryAssociationRequest;
(function (DescribeRepositoryAssociationRequest) {
    DescribeRepositoryAssociationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeRepositoryAssociationRequest || (DescribeRepositoryAssociationRequest = {}));
export var DescribeRepositoryAssociationResponse;
(function (DescribeRepositoryAssociationResponse) {
    DescribeRepositoryAssociationResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeRepositoryAssociationResponse || (DescribeRepositoryAssociationResponse = {}));
var NotFoundException = (function (_super) {
    __extends(NotFoundException, _super);
    function NotFoundException(opts) {
        var _this = _super.call(this, __assign({ name: "NotFoundException", $fault: "client" }, opts)) || this;
        _this.name = "NotFoundException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, NotFoundException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return NotFoundException;
}(__BaseException));
export { NotFoundException };
export var DisassociateRepositoryRequest;
(function (DisassociateRepositoryRequest) {
    DisassociateRepositoryRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DisassociateRepositoryRequest || (DisassociateRepositoryRequest = {}));
export var DisassociateRepositoryResponse;
(function (DisassociateRepositoryResponse) {
    DisassociateRepositoryResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DisassociateRepositoryResponse || (DisassociateRepositoryResponse = {}));
export var ListCodeReviewsRequest;
(function (ListCodeReviewsRequest) {
    ListCodeReviewsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListCodeReviewsRequest || (ListCodeReviewsRequest = {}));
export var MetricsSummary;
(function (MetricsSummary) {
    MetricsSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(MetricsSummary || (MetricsSummary = {}));
export var CodeReviewSummary;
(function (CodeReviewSummary) {
    CodeReviewSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CodeReviewSummary || (CodeReviewSummary = {}));
export var ListCodeReviewsResponse;
(function (ListCodeReviewsResponse) {
    ListCodeReviewsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListCodeReviewsResponse || (ListCodeReviewsResponse = {}));
export var ListRecommendationFeedbackRequest;
(function (ListRecommendationFeedbackRequest) {
    ListRecommendationFeedbackRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListRecommendationFeedbackRequest || (ListRecommendationFeedbackRequest = {}));
export var RecommendationFeedbackSummary;
(function (RecommendationFeedbackSummary) {
    RecommendationFeedbackSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RecommendationFeedbackSummary || (RecommendationFeedbackSummary = {}));
export var ListRecommendationFeedbackResponse;
(function (ListRecommendationFeedbackResponse) {
    ListRecommendationFeedbackResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListRecommendationFeedbackResponse || (ListRecommendationFeedbackResponse = {}));
export var ListRecommendationsRequest;
(function (ListRecommendationsRequest) {
    ListRecommendationsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListRecommendationsRequest || (ListRecommendationsRequest = {}));
export var RecommendationCategory;
(function (RecommendationCategory) {
    RecommendationCategory["AWS_BEST_PRACTICES"] = "AWSBestPractices";
    RecommendationCategory["AWS_CLOUDFORMATION_ISSUES"] = "AWSCloudFormationIssues";
    RecommendationCategory["CODE_INCONSISTENCIES"] = "CodeInconsistencies";
    RecommendationCategory["CODE_MAINTENANCE_ISSUES"] = "CodeMaintenanceIssues";
    RecommendationCategory["CONCURRENCY_ISSUES"] = "ConcurrencyIssues";
    RecommendationCategory["DUPLICATE_CODE"] = "DuplicateCode";
    RecommendationCategory["INPUT_VALIDATIONS"] = "InputValidations";
    RecommendationCategory["JAVA_BEST_PRACTICES"] = "JavaBestPractices";
    RecommendationCategory["PYTHON_BEST_PRACTICES"] = "PythonBestPractices";
    RecommendationCategory["RESOURCE_LEAKS"] = "ResourceLeaks";
    RecommendationCategory["SECURITY_ISSUES"] = "SecurityIssues";
})(RecommendationCategory || (RecommendationCategory = {}));
export var RuleMetadata;
(function (RuleMetadata) {
    RuleMetadata.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RuleMetadata || (RuleMetadata = {}));
export var Severity;
(function (Severity) {
    Severity["CRITICAL"] = "Critical";
    Severity["HIGH"] = "High";
    Severity["INFO"] = "Info";
    Severity["LOW"] = "Low";
    Severity["MEDIUM"] = "Medium";
})(Severity || (Severity = {}));
export var RecommendationSummary;
(function (RecommendationSummary) {
    RecommendationSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RecommendationSummary || (RecommendationSummary = {}));
export var ListRecommendationsResponse;
(function (ListRecommendationsResponse) {
    ListRecommendationsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListRecommendationsResponse || (ListRecommendationsResponse = {}));
export var ListRepositoryAssociationsRequest;
(function (ListRepositoryAssociationsRequest) {
    ListRepositoryAssociationsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListRepositoryAssociationsRequest || (ListRepositoryAssociationsRequest = {}));
export var RepositoryAssociationSummary;
(function (RepositoryAssociationSummary) {
    RepositoryAssociationSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RepositoryAssociationSummary || (RepositoryAssociationSummary = {}));
export var ListRepositoryAssociationsResponse;
(function (ListRepositoryAssociationsResponse) {
    ListRepositoryAssociationsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListRepositoryAssociationsResponse || (ListRepositoryAssociationsResponse = {}));
export var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceRequest || (ListTagsForResourceRequest = {}));
export var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceResponse || (ListTagsForResourceResponse = {}));
export var PutRecommendationFeedbackRequest;
(function (PutRecommendationFeedbackRequest) {
    PutRecommendationFeedbackRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(PutRecommendationFeedbackRequest || (PutRecommendationFeedbackRequest = {}));
export var PutRecommendationFeedbackResponse;
(function (PutRecommendationFeedbackResponse) {
    PutRecommendationFeedbackResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(PutRecommendationFeedbackResponse || (PutRecommendationFeedbackResponse = {}));
export var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceRequest || (TagResourceRequest = {}));
export var TagResourceResponse;
(function (TagResourceResponse) {
    TagResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceResponse || (TagResourceResponse = {}));
export var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceRequest || (UntagResourceRequest = {}));
export var UntagResourceResponse;
(function (UntagResourceResponse) {
    UntagResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceResponse || (UntagResourceResponse = {}));
