import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import { AssociateRepositoryCommandInput, AssociateRepositoryCommandOutput } from "../commands/AssociateRepositoryCommand";
import { CreateCodeReviewCommandInput, CreateCodeReviewCommandOutput } from "../commands/CreateCodeReviewCommand";
import { DescribeCodeReviewCommandInput, DescribeCodeReviewCommandOutput } from "../commands/DescribeCodeReviewCommand";
import { DescribeRecommendationFeedbackCommandInput, DescribeRecommendationFeedbackCommandOutput } from "../commands/DescribeRecommendationFeedbackCommand";
import { DescribeRepositoryAssociationCommandInput, DescribeRepositoryAssociationCommandOutput } from "../commands/DescribeRepositoryAssociationCommand";
import { DisassociateRepositoryCommandInput, DisassociateRepositoryCommandOutput } from "../commands/DisassociateRepositoryCommand";
import { ListCodeReviewsCommandInput, ListCodeReviewsCommandOutput } from "../commands/ListCodeReviewsCommand";
import { ListRecommendationFeedbackCommandInput, ListRecommendationFeedbackCommandOutput } from "../commands/ListRecommendationFeedbackCommand";
import { ListRecommendationsCommandInput, ListRecommendationsCommandOutput } from "../commands/ListRecommendationsCommand";
import { ListRepositoryAssociationsCommandInput, ListRepositoryAssociationsCommandOutput } from "../commands/ListRepositoryAssociationsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { PutRecommendationFeedbackCommandInput, PutRecommendationFeedbackCommandOutput } from "../commands/PutRecommendationFeedbackCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
export declare const serializeAws_restJson1AssociateRepositoryCommand: (input: AssociateRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateCodeReviewCommand: (input: CreateCodeReviewCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeCodeReviewCommand: (input: DescribeCodeReviewCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeRecommendationFeedbackCommand: (input: DescribeRecommendationFeedbackCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeRepositoryAssociationCommand: (input: DescribeRepositoryAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DisassociateRepositoryCommand: (input: DisassociateRepositoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListCodeReviewsCommand: (input: ListCodeReviewsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListRecommendationFeedbackCommand: (input: ListRecommendationFeedbackCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListRecommendationsCommand: (input: ListRecommendationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListRepositoryAssociationsCommand: (input: ListRepositoryAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1PutRecommendationFeedbackCommand: (input: PutRecommendationFeedbackCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const deserializeAws_restJson1AssociateRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateRepositoryCommandOutput>;
export declare const deserializeAws_restJson1CreateCodeReviewCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCodeReviewCommandOutput>;
export declare const deserializeAws_restJson1DescribeCodeReviewCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCodeReviewCommandOutput>;
export declare const deserializeAws_restJson1DescribeRecommendationFeedbackCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeRecommendationFeedbackCommandOutput>;
export declare const deserializeAws_restJson1DescribeRepositoryAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeRepositoryAssociationCommandOutput>;
export declare const deserializeAws_restJson1DisassociateRepositoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateRepositoryCommandOutput>;
export declare const deserializeAws_restJson1ListCodeReviewsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListCodeReviewsCommandOutput>;
export declare const deserializeAws_restJson1ListRecommendationFeedbackCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListRecommendationFeedbackCommandOutput>;
export declare const deserializeAws_restJson1ListRecommendationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListRecommendationsCommandOutput>;
export declare const deserializeAws_restJson1ListRepositoryAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListRepositoryAssociationsCommandOutput>;
export declare const deserializeAws_restJson1ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
export declare const deserializeAws_restJson1PutRecommendationFeedbackCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutRecommendationFeedbackCommandOutput>;
export declare const deserializeAws_restJson1TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
export declare const deserializeAws_restJson1UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
