import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { AssociateRepositoryRequest, AssociateRepositoryResponse } from "../models/models_0";
export interface AssociateRepositoryCommandInput extends AssociateRepositoryRequest {
}
export interface AssociateRepositoryCommandOutput extends AssociateRepositoryResponse, __MetadataBearer {
}

export declare class AssociateRepositoryCommand extends $Command<AssociateRepositoryCommandInput, AssociateRepositoryCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: AssociateRepositoryCommandInput;
    constructor(input: AssociateRepositoryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<AssociateRepositoryCommandInput, AssociateRepositoryCommandOutput>;
    private serialize;
    private deserialize;
}
