import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { CreateCodeReviewRequest, CreateCodeReviewResponse } from "../models/models_0";
export interface CreateCodeReviewCommandInput extends CreateCodeReviewRequest {
}
export interface CreateCodeReviewCommandOutput extends CreateCodeReviewResponse, __MetadataBearer {
}

export declare class CreateCodeReviewCommand extends $Command<CreateCodeReviewCommandInput, CreateCodeReviewCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: CreateCodeReviewCommandInput;
    constructor(input: CreateCodeReviewCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateCodeReviewCommandInput, CreateCodeReviewCommandOutput>;
    private serialize;
    private deserialize;
}
