import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { DescribeCodeReviewRequest, DescribeCodeReviewResponse } from "../models/models_0";
export interface DescribeCodeReviewCommandInput extends DescribeCodeReviewRequest {
}
export interface DescribeCodeReviewCommandOutput extends DescribeCodeReviewResponse, __MetadataBearer {
}

export declare class DescribeCodeReviewCommand extends $Command<DescribeCodeReviewCommandInput, DescribeCodeReviewCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: DescribeCodeReviewCommandInput;
    constructor(input: DescribeCodeReviewCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeCodeReviewCommandInput, DescribeCodeReviewCommandOutput>;
    private serialize;
    private deserialize;
}
