import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { DescribeRecommendationFeedbackRequest, DescribeRecommendationFeedbackResponse } from "../models/models_0";
export interface DescribeRecommendationFeedbackCommandInput extends DescribeRecommendationFeedbackRequest {
}
export interface DescribeRecommendationFeedbackCommandOutput extends DescribeRecommendationFeedbackResponse, __MetadataBearer {
}

export declare class DescribeRecommendationFeedbackCommand extends $Command<DescribeRecommendationFeedbackCommandInput, DescribeRecommendationFeedbackCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: DescribeRecommendationFeedbackCommandInput;
    constructor(input: DescribeRecommendationFeedbackCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeRecommendationFeedbackCommandInput, DescribeRecommendationFeedbackCommandOutput>;
    private serialize;
    private deserialize;
}
