import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { DescribeRepositoryAssociationRequest, DescribeRepositoryAssociationResponse } from "../models/models_0";
export interface DescribeRepositoryAssociationCommandInput extends DescribeRepositoryAssociationRequest {
}
export interface DescribeRepositoryAssociationCommandOutput extends DescribeRepositoryAssociationResponse, __MetadataBearer {
}

export declare class DescribeRepositoryAssociationCommand extends $Command<DescribeRepositoryAssociationCommandInput, DescribeRepositoryAssociationCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: DescribeRepositoryAssociationCommandInput;
    constructor(input: DescribeRepositoryAssociationCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeRepositoryAssociationCommandInput, DescribeRepositoryAssociationCommandOutput>;
    private serialize;
    private deserialize;
}
