import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { DisassociateRepositoryRequest, DisassociateRepositoryResponse } from "../models/models_0";
export interface DisassociateRepositoryCommandInput extends DisassociateRepositoryRequest {
}
export interface DisassociateRepositoryCommandOutput extends DisassociateRepositoryResponse, __MetadataBearer {
}

export declare class DisassociateRepositoryCommand extends $Command<DisassociateRepositoryCommandInput, DisassociateRepositoryCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: DisassociateRepositoryCommandInput;
    constructor(input: DisassociateRepositoryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DisassociateRepositoryCommandInput, DisassociateRepositoryCommandOutput>;
    private serialize;
    private deserialize;
}
