import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { ListCodeReviewsRequest, ListCodeReviewsResponse } from "../models/models_0";
export interface ListCodeReviewsCommandInput extends ListCodeReviewsRequest {
}
export interface ListCodeReviewsCommandOutput extends ListCodeReviewsResponse, __MetadataBearer {
}

export declare class ListCodeReviewsCommand extends $Command<ListCodeReviewsCommandInput, ListCodeReviewsCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: ListCodeReviewsCommandInput;
    constructor(input: ListCodeReviewsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListCodeReviewsCommandInput, ListCodeReviewsCommandOutput>;
    private serialize;
    private deserialize;
}
