import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { ListRecommendationFeedbackRequest, ListRecommendationFeedbackResponse } from "../models/models_0";
export interface ListRecommendationFeedbackCommandInput extends ListRecommendationFeedbackRequest {
}
export interface ListRecommendationFeedbackCommandOutput extends ListRecommendationFeedbackResponse, __MetadataBearer {
}

export declare class ListRecommendationFeedbackCommand extends $Command<ListRecommendationFeedbackCommandInput, ListRecommendationFeedbackCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: ListRecommendationFeedbackCommandInput;
    constructor(input: ListRecommendationFeedbackCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListRecommendationFeedbackCommandInput, ListRecommendationFeedbackCommandOutput>;
    private serialize;
    private deserialize;
}
