import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { ListRepositoryAssociationsRequest, ListRepositoryAssociationsResponse } from "../models/models_0";
export interface ListRepositoryAssociationsCommandInput extends ListRepositoryAssociationsRequest {
}
export interface ListRepositoryAssociationsCommandOutput extends ListRepositoryAssociationsResponse, __MetadataBearer {
}

export declare class ListRepositoryAssociationsCommand extends $Command<ListRepositoryAssociationsCommandInput, ListRepositoryAssociationsCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: ListRepositoryAssociationsCommandInput;
    constructor(input: ListRepositoryAssociationsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListRepositoryAssociationsCommandInput, ListRepositoryAssociationsCommandOutput>;
    private serialize;
    private deserialize;
}
