import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeGuruReviewerClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeGuruReviewerClient";
import { PutRecommendationFeedbackRequest, PutRecommendationFeedbackResponse } from "../models/models_0";
export interface PutRecommendationFeedbackCommandInput extends PutRecommendationFeedbackRequest {
}
export interface PutRecommendationFeedbackCommandOutput extends PutRecommendationFeedbackResponse, __MetadataBearer {
}

export declare class PutRecommendationFeedbackCommand extends $Command<PutRecommendationFeedbackCommandInput, PutRecommendationFeedbackCommandOutput, CodeGuruReviewerClientResolvedConfig> {
    readonly input: PutRecommendationFeedbackCommandInput;
    constructor(input: PutRecommendationFeedbackCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeGuruReviewerClientResolvedConfig, options?: __HttpHandlerOptions): Handler<PutRecommendationFeedbackCommandInput, PutRecommendationFeedbackCommandOutput>;
    private serialize;
    private deserialize;
}
