import { WaiterConfiguration, WaiterResult } from "@aws-sdk/util-waiter";
import { CodeGuruReviewerClient } from "../CodeGuruReviewerClient";
import { DescribeCodeReviewCommandInput } from "../commands/DescribeCodeReviewCommand";
/**
 * Wait until a code review is complete.
 *  @deprecated Use waitUntilCodeReviewCompleted instead. waitForCodeReviewCompleted does not throw error in non-success cases.
 */
export declare const waitForCodeReviewCompleted: (params: WaiterConfiguration<CodeGuruReviewerClient>, input: DescribeCodeReviewCommandInput) => Promise<WaiterResult>;
/**
 * Wait until a code review is complete.
 *  @param params - Waiter configuration options.
 *  @param input - The input to DescribeCodeReviewCommand for polling.
 */
export declare const waitUntilCodeReviewCompleted: (params: WaiterConfiguration<CodeGuruReviewerClient>, input: DescribeCodeReviewCommandInput) => Promise<WaiterResult>;
