import { WaiterConfiguration, WaiterResult } from "@aws-sdk/util-waiter";
import { CodeGuruReviewerClient } from "../CodeGuruReviewerClient";
import { DescribeRepositoryAssociationCommandInput } from "../commands/DescribeRepositoryAssociationCommand";
/**
 * Wait until a repository association is complete.
 *  @deprecated Use waitUntilRepositoryAssociationSucceeded instead. waitForRepositoryAssociationSucceeded does not throw error in non-success cases.
 */
export declare const waitForRepositoryAssociationSucceeded: (params: WaiterConfiguration<CodeGuruReviewerClient>, input: DescribeRepositoryAssociationCommandInput) => Promise<WaiterResult>;
/**
 * Wait until a repository association is complete.
 *  @param params - Waiter configuration options.
 *  @param input - The input to DescribeRepositoryAssociationCommand for polling.
 */
export declare const waitUntilRepositoryAssociationSucceeded: (params: WaiterConfiguration<CodeGuruReviewerClient>, input: DescribeRepositoryAssociationCommandInput) => Promise<WaiterResult>;
